Skip to content

Commit

Permalink
Add release.sh script
Browse files Browse the repository at this point in the history
  • Loading branch information
vmihailenco committed Aug 11, 2021
1 parent 11f9065 commit 7cfc5cb
Show file tree
Hide file tree
Showing 15 changed files with 152 additions and 20 deletions.
20 changes: 0 additions & 20 deletions Makefile
Original file line number Diff line number Diff line change
Expand Up @@ -8,26 +8,6 @@ test:
go vet); \
done

tag:
go mod edit -require github.com/uptrace/bun@v$(VERSION) dialect/pgdialect/go.mod
go mod edit -require github.com/uptrace/bun@v$(VERSION) dialect/mysqldialect/go.mod
go mod edit -require github.com/uptrace/bun@v$(VERSION) dialect/sqlitedialect/go.mod
go mod edit -require github.com/uptrace/bun@v$(VERSION) driver/pgdriver/go.mod
go mod edit -require github.com/uptrace/bun@v$(VERSION) dbfixture/go.mod
go mod edit -require github.com/uptrace/bun@v$(VERSION) extra/bundebug/go.mod
go mod edit -require github.com/uptrace/bun@v$(VERSION) extra/bunotel/go.mod
git add \*.mod
git commit -m "Bump to version $(VERSION)"
git tag $(VERSION)
git tag dialect/pgdialect/$(VERSION)
git tag dialect/mysqldialect/$(VERSION)
git tag dialect/sqlitedialect/$(VERSION)
git tag driver/pgdriver/$(VERSION)
git tag driver/sqliteshim/$(VERSION)
git tag dbfixture/$(VERSION)
git tag extra/bundebug/$(VERSION)
git tag extra/bunotel/$(VERSION)

go_mod_tidy:
set -e; for dir in $(ALL_GO_MOD_DIRS); do \
echo "go mod tidy in $${dir}"; \
Expand Down
21 changes: 21 additions & 0 deletions RELEASING.md
Original file line number Diff line number Diff line change
@@ -0,0 +1,21 @@
# Releasing

1. Run `release.sh` script which updates versions in go.mod files and pushes a new branch to GitHub:

```shell
./scripts/release.sh -t v1.0.0
```

2. Open a pull request and wait for the build to finish.

3. Merge the pull request and run `tag.sh` to create tags for packages:

```shell
./scripts/tag.sh -t v1.0.0
```

4. Push the tags:

```shell
git push origin --tags
```
2 changes: 2 additions & 0 deletions example/basic/go.mod
Original file line number Diff line number Diff line change
Expand Up @@ -10,6 +10,8 @@ replace github.com/uptrace/bun/extra/bundebug => ../../extra/bundebug

replace github.com/uptrace/bun/dialect/sqlitedialect => ../../dialect/sqlitedialect

replace github.com/uptrace/bun/driver/sqliteshim => ../../driver/sqliteshim

require (
github.com/uptrace/bun v0.1.1
github.com/uptrace/bun/dbfixture v0.0.0-00010101000000-000000000000
Expand Down
2 changes: 2 additions & 0 deletions example/belongs-to/go.mod
Original file line number Diff line number Diff line change
Expand Up @@ -8,6 +8,8 @@ replace github.com/uptrace/bun/extra/bundebug => ../../extra/bundebug

replace github.com/uptrace/bun/dialect/sqlitedialect => ../../dialect/sqlitedialect

replace github.com/uptrace/bun/driver/sqliteshim => ../../driver/sqliteshim

require (
github.com/uptrace/bun v0.1.1
github.com/uptrace/bun/dialect/sqlitedialect v0.0.0-20210507070510-0d95488a5553
Expand Down
2 changes: 2 additions & 0 deletions example/create-table-index/go.mod
Original file line number Diff line number Diff line change
Expand Up @@ -8,6 +8,8 @@ replace github.com/uptrace/bun/extra/bundebug => ../../extra/bundebug

replace github.com/uptrace/bun/dialect/sqlitedialect => ../../dialect/sqlitedialect

replace github.com/uptrace/bun/driver/sqliteshim => ../../driver/sqliteshim

require (
github.com/uptrace/bun v0.1.1
github.com/uptrace/bun/dialect/sqlitedialect v0.0.0-00010101000000-000000000000
Expand Down
2 changes: 2 additions & 0 deletions example/fixture/go.mod
Original file line number Diff line number Diff line change
Expand Up @@ -8,6 +8,8 @@ replace github.com/uptrace/bun/extra/bundebug => ../../extra/bundebug

replace github.com/uptrace/bun/dialect/sqlitedialect => ../../dialect/sqlitedialect

replace github.com/uptrace/bun/driver/sqliteshim => ../../driver/sqliteshim

replace github.com/uptrace/bun/dbfixture => ../../dbfixture

require (
Expand Down
2 changes: 2 additions & 0 deletions example/has-many/go.mod
Original file line number Diff line number Diff line change
Expand Up @@ -8,6 +8,8 @@ replace github.com/uptrace/bun/extra/bundebug => ../../extra/bundebug

replace github.com/uptrace/bun/dialect/sqlitedialect => ../../dialect/sqlitedialect

replace github.com/uptrace/bun/driver/sqliteshim => ../../driver/sqliteshim

require (
github.com/uptrace/bun v0.1.1
github.com/uptrace/bun/dialect/sqlitedialect v0.0.0-20210507070510-0d95488a5553
Expand Down
2 changes: 2 additions & 0 deletions example/has-one/go.mod
Original file line number Diff line number Diff line change
Expand Up @@ -8,6 +8,8 @@ replace github.com/uptrace/bun/extra/bundebug => ../../extra/bundebug

replace github.com/uptrace/bun/dialect/sqlitedialect => ../../dialect/sqlitedialect

replace github.com/uptrace/bun/driver/sqliteshim => ../../driver/sqliteshim

require (
github.com/uptrace/bun v0.1.1
github.com/uptrace/bun/dialect/sqlitedialect v0.0.0-20210507070510-0d95488a5553
Expand Down
2 changes: 2 additions & 0 deletions example/many-to-many/go.mod
Original file line number Diff line number Diff line change
Expand Up @@ -8,6 +8,8 @@ replace github.com/uptrace/bun/extra/bundebug => ../../extra/bundebug

replace github.com/uptrace/bun/dialect/sqlitedialect => ../../dialect/sqlitedialect

replace github.com/uptrace/bun/driver/sqliteshim => ../../driver/sqliteshim

require (
github.com/uptrace/bun v0.1.1
github.com/uptrace/bun/dialect/sqlitedialect v0.0.0-20210507070510-0d95488a5553
Expand Down
2 changes: 2 additions & 0 deletions example/migrate/go.mod
Original file line number Diff line number Diff line change
Expand Up @@ -8,6 +8,8 @@ replace github.com/uptrace/bun/extra/bundebug => ../../extra/bundebug

replace github.com/uptrace/bun/dialect/sqlitedialect => ../../dialect/sqlitedialect

replace github.com/uptrace/bun/driver/sqliteshim => ../../driver/sqliteshim

require (
github.com/cpuguy83/go-md2man/v2 v2.0.0 // indirect
github.com/russross/blackfriday/v2 v2.1.0 // indirect
Expand Down
2 changes: 2 additions & 0 deletions example/model-hooks/go.mod
Original file line number Diff line number Diff line change
Expand Up @@ -10,6 +10,8 @@ replace github.com/uptrace/bun/extra/bundebug => ../../extra/bundebug

replace github.com/uptrace/bun/dialect/sqlitedialect => ../../dialect/sqlitedialect

replace github.com/uptrace/bun/driver/sqliteshim => ../../driver/sqliteshim

require (
github.com/davecgh/go-spew v1.1.1
github.com/uptrace/bun v0.1.1
Expand Down
2 changes: 2 additions & 0 deletions example/tx-composition/go.mod
Original file line number Diff line number Diff line change
Expand Up @@ -10,6 +10,8 @@ replace github.com/uptrace/bun/extra/bundebug => ../../extra/bundebug

replace github.com/uptrace/bun/dialect/sqlitedialect => ../../dialect/sqlitedialect

replace github.com/uptrace/bun/driver/sqliteshim => ../../driver/sqliteshim

require (
github.com/uptrace/bun v0.1.1
github.com/uptrace/bun/dialect/sqlitedialect v0.0.0-20210507070510-0d95488a5553
Expand Down
65 changes: 65 additions & 0 deletions scripts/release.sh
Original file line number Diff line number Diff line change
@@ -0,0 +1,65 @@
#!/bin/bash

set -e

help() {
cat <<- EOF
Usage: TAG=tag $0
Updates version in go.mod files and pushes a new brash to GitHub.
VARIABLES:
TAG git tag, for example, v1.0.0
EOF
exit 0
}

if [ -z "$TAG" ]
then
printf "TAG is required\n\n"
help
fi

TAG_REGEX="^v(0|[1-9][0-9]*)\\.(0|[1-9][0-9]*)\\.(0|[1-9][0-9]*)(\\-[0-9A-Za-z-]+(\\.[0-9A-Za-z-]+)*)?(\\+[0-9A-Za-z-]+(\\.[0-9A-Za-z-]+)*)?$"
if ! [[ "${TAG}" =~ ${TAG_REGEX} ]]; then
printf "TAG is not valid: ${TAG}\n\n"
exit 1
fi

TAG_FOUND=`git tag --list ${TAG}`
if [[ ${TAG_FOUND} = ${TAG} ]] ; then
printf "tag ${TAG} already exists\n\n"
exit 1
fi

if ! git diff --quiet
then
printf "working tree is not clean\n\n"
git status
exit 1
fi

git checkout master

PACKAGE_DIRS=$(find . -mindepth 2 -type f -name 'go.mod' -exec dirname {} \; \
| sed 's/^\.\///' \
| sort)

for dir in $PACKAGE_DIRS
do
sed --in-place \
"s/uptrace\/bun\([^ ]*\) v.*/uptrace\/bun\1 ${TAG}/" "${dir}/go.mod"
done

for dir in $PACKAGE_DIRS
do
printf "${dir}: go mod tidy\n"
(cd ./${dir} && go mod tidy)
done

sed --in-place "s/\(return \)\"[^\"]*\"/\1\"${TAG#v}\"/" ./version.go

git checkout -b release/${TAG} master
git add -u
git commit -m "Release $TAG"
git push origin release/${TAG}
40 changes: 40 additions & 0 deletions scripts/tag.sh
Original file line number Diff line number Diff line change
@@ -0,0 +1,40 @@
#!/bin/bash

set -e

help() {
cat <<- EOF
Usage: TAG=tag $0
Creates git tags for public Go packages.
VARIABLES:
TAG git tag, for example, v1.0.0
EOF
exit 0
}

if [ -z "$TAG" ]
then
printf "TAG env var is required\n\n";
help
fi

if ! grep -Fq "\"${TAG#v}\"" version.go
then
printf "version.go does not contain ${TAG#v}\n"
exit 1
fi

PACKAGE_DIRS=$(find . -mindepth 2 -type f -name 'go.mod' -exec dirname {} \; \
| grep -E -v "example|internal" \
| sed 's/^\.\///' \
| sort)

git tag ${TAG}

for dir in $PACKAGE_DIRS
do
printf "tagging ${dir}/${TAG}\n"
git tag ${dir}/${TAG}
done
6 changes: 6 additions & 0 deletions version.go
Original file line number Diff line number Diff line change
@@ -0,0 +1,6 @@
package bun

// Version is the current release version.
func Version() string {
return "0.0.1"
}

0 comments on commit 7cfc5cb

Please sign in to comment.